unit U_YFKInput;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, cxStyles, cxCustomData, cxGraphics, cxFilter,
  cxData, cxDataStorage, cxEdit, DB, cxDBData, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxGrid, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB,
  DBClient, ExtCtrls, StdCtrls, BtnEdit, cxButtonEdit, cxTextEdit,
  cxDropDownEdit, cxLookAndFeels, cxLookAndFeelPainters, cxNavigator;

type
  TfrmYFKInput = class(TForm)
    DataSource1: TDataSource;
    YFSub: TClientDataSet;
    cxGridPopupMenu1: TcxGridPopupMenu;
    ToolBar1: TToolBar;
    TSave: TToolButton;
    TBClose: TToolButton;
    ToolBar2: TToolBar;
    TADD: TToolButton;
    TDEl: TToolButton;
    Panel1: TPanel;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1_KXType: TcxGridDBColumn;
    v1Qty: TcxGridDBColumn;
    v1Price: TcxGridDBColumn;
    v1QtyUnit: TcxGridDBColumn;
    v1Money: TcxGridDBColumn;
    v1note: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    Label1: TLabel;
    YFID: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    CRTime: TDateTimePicker;
    Note: TMemo;
    PayMent: TBtnEditA;
    FactoryName: TBtnEditA;
    Label4: TLabel;
    Label6: TLabel;
    ADOQueryTmp: TADOQuery;
    ADOQueryCmd: TADOQuery;
    Label8: TLabel;
    SYRName: TBtnEditA;
    Label9: TLabel;
    Money: TEdit;
    Label10: TLabel;
    HuiLv: TEdit;
    BZType: TComboBox;
    Label11: TLabel;
    Label12: TLabel;
    BBMoney: TEdit;
    v1Column1: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    Label7: TLabel;
    v1Column4: TcxGridDBColumn;
    ToolButton1: TToolButton;
    v1Column5: TcxGridDBColumn;
    Label5: TLabel;
    ishs: TComboBox;
    v1Column6: TcxGridDBColumn;
    YFName: TBtnEditA;
    YFGSType: TComboBox;
    Label14: TLabel;
    Label13: TLabel;
    FtySYRName: TBtnEditA;
    ToolButton4: TToolButton;
    Label15: TLabel;
    YFPZNOHZ: TEdit;
    v1Column7: TcxGridDBColumn;
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TSaveClick(Sender: TObject);
    procedure FactoryNameBtnClick(Sender: TObject);
    procedure PayMentBtnClick(Sender: TObject);
    procedure v1P_SpecPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1QtyUnitPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure TADDClick(Sender: TObject);
    procedure TDElClick(Sender: TObject);
    procedure v1QtyPropertiesEditValueChanged(Sender: TObject);
    procedure SYRNameBtnClick(Sender: TObject);
    procedure v1Column3PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure HuiLvKeyPress(Sender: TObject; var Key: Char);
    procedure Panel1Click(Sender: TObject);
    procedure HuiLvExit(Sender: TObject);
    procedure v1MoneyPropertiesEditValueChanged(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure YFNameBtnClick(Sender: TObject);
    procedure FtySYRNameBtnClick(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
  private
    procedure initGrid();
    procedure SaveDate();
    procedure HJJE();
    { Private declarations }
  public
    FYFID: string;
    { Public declarations }
  end;

var
  frmYFKInput: TfrmYFKInput;

implementation

uses
  U_Fun10, U_ZDYHelp, U_ZdyAttachment, U_dataLink, U_ZdyAttachGYS, U_SXCKNewList,
  U_PBRKlistSel, U_CPManageSel, U_ZZJWLRKListSel, U_ProductFileSel,
  U_MLRKlistSel;
{$R *.dfm}

procedure TfrmYFKInput.HJJE();
var
  FMoney, FHuiLv, FBBMoney: double;
begin
  if TV1.DataController.Summary.FooterSummaryValues[1] <> NULL then
    FMoney := TV1.DataController.Summary.FooterSummaryValues[1]
  else
    FMoney := 0;

  FHuiLv := strtofloat(HuiLv.Text);
  if FHuiLv = 0 then
    FHuiLv := 1;
  FBBMoney := FHuiLv * FMoney;
  Money.Text := floattostr(FMoney);
  HuiLv.Text := floattostr(FHuiLv);
  BBMoney.Text := floattostr(FBBMoney);
end;

procedure TfrmYFKInput.SaveDate();
var
  MaxYFSID, MaxYFID: string;
begin
  ADOQueryCmd.Connection.BeginTrans;
  try
    if trim(FYFID) = '' then
    begin
      if GetLSNo(ADOQueryTmp, MaxYFID, 'YF', 'YF_Money_CR_Sub2', 4, 1) = False then
      begin
        Application.MessageBox('取最大号失败！', '提示', 0);
        Exit;
      end;
      YFID.Text := MaxYFID;
    end
    else
    begin
      MaxYFID := trim(FYFID);
    end;
    with ADOQueryCmd do
    begin
      close;
      sql.Clear;
      sql.add('select * from YF_Money_CR2 where YFID=' + quotedstr(FYFID));
      open;
    end;
    with ADOQueryCmd do
    begin
      if trim(FYFID) = '' then
      begin
        append;
        Fieldbyname('YFID').value := trim(MaxYFID);
        FieldByName('CRType').Value := '应付款登记';
        FieldByName('CRFlag').Value := '应付付';
        FieldByName('QtyFlag').Value := 1;
        FieldByName('status').Value := '0';
        FieldByName('Filler').Value := Trim(DName);
      end
      else
      begin
        edit;
        FieldByName('Editer').Value := Trim(DName);
        FieldByName('EditTime').Value := SGetServerDateTime(ADOQueryTmp);
      end;

      SSetsaveSqlnew(ADOQueryCmd, 'YF_Money_CR2', panel1, 0);
      post;
    end;

    with YFSub do
    begin
      first;
      while not eof do
      begin
        if fieldbyname('YFSID').AsString = '' then
        begin
          if GetLSNo(ADOQueryTmp, MaxYFSID, 'YFS', 'YF_Money_CR_Sub2', 4, 1) = False then
          begin
            Application.MessageBox('取最大号失败！', '提示', 0);
            Exit;
          end;
        end
        else
        begin
          MaxYFSID := YFSub.fieldbyname('YFSID').AsString;
        end;
        with ADOQueryCmd do
        begin
          close;
          sql.Clear;
          sql.add('select * from YF_Money_CR_Sub2 where YFSID=' + Quotedstr(trim(MaxYFSID)));
          open;
        end;
        if ADOQueryCmd.IsEmpty then
        begin
          ADOQueryCmd.append;
          ADOQueryCmd.Fieldbyname('YFSID').value := trim(MaxYFSID);
          ADOQueryCmd.Fieldbyname('YFID').value := trim(MaxYFID);
        end
        else
        begin
          ADOQueryCmd.edit;
        end;

        SSetSaveDataCDSNew(ADOQueryCmd, Tv1, YFSub, 'YF_Money_CR_Sub2', 0);
        ADOQueryCmd.Post;
        next;
      end;
    end;
    ADOQueryCmd.Connection.CommitTrans;
    application.MessageBox('保存成功！', '提示');
    Modalresult := 1;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox('保存失败！', '提示', MB_ICONERROR);
  end;
end;

procedure TfrmYFKInput.initGrid();
begin
  with ADOQueryTmp do
  begin
    close;
    sql.Clear;
    sql.Add('select * from YF_Money_CR2 where YFID=' + quotedstr(trim(FYFID)));
    open;
  end;
  if ADOQueryTmp.isempty = False then
  begin
    SCSHDataNew(ADOQueryTmp, Panel1, 0);
  end
  else
  begin
    HuiLv.Text := '1';
    CRTime.DateTime := SGetServerDate(ADOQueryTmp);
  end;
  with ADOQueryTmp do
  begin
    close;
    sql.Clear;
    sql.Add('select * from YF_Money_CR_Sub2 where YFID=''' + trim(FYFID) + '''');
    open;
  end;
  SCreateCDS20(ADOQueryTmp, YFSub);
  SInitCDSData20(ADOQueryTmp, YFSub);
end;

procedure TfrmYFKInput.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid(trim(self.Caption), Tv1, '财务管理');
  Close;
end;

procedure TfrmYFKInput.FormShow(Sender: TObject);
begin
  ReadCxGrid(trim(self.Caption), Tv1, '财务管理');
  initGrid();
end;

procedure TfrmYFKInput.TSaveClick(Sender: TObject);
begin
  yfname.SetFocus;
  if trim(FactoryName.Text) = '' then
  begin
    application.MessageBox('对方单位不能为空', '提示');
    exit;
  end;
  if trim(YFGSType.Text) = '' then
  begin
    application.MessageBox('应付类别不能为空', '提示');
    exit;
  end;
  if trim(ishs.Text) = '' then
  begin
    application.MessageBox('是否含税不能为空', '提示');
    exit;
  end;
  if YFSub.Locate('KXType', null, []) then
  begin
    application.MessageBox('款项类型不能为空', '提示');
    exit;
  end;
  if YFSub.Locate('KXType', '', []) then
  begin
    application.MessageBox('款项类型不能为空', '提示');
    exit;
  end;
  SaveDate();
end;

procedure TfrmYFKInput.FactoryNameBtnClick(Sender: TObject);
begin

  try
    frmZdyAttachGYS := TfrmZdyAttachGYS.Create(Application);
    with frmZdyAttachGYS do
    begin
      if ShowModal = 1 then
      begin
        FactoryName.Text := Trim(CDS_HZ.fieldbyname('CoName').AsString);
        FtySYRName.Text := Trim(CDS_HZ.fieldbyname('CoName').AsString);
      end;
    end;
  finally
    frmZdyAttachGYS.Free;
  end;

end;

procedure TfrmYFKInput.PayMentBtnClick(Sender: TObject);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'PayMent';
      flagname := '付款方式';
      if ShowModal = 1 then
      begin
        PayMent.Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYFKInput.v1P_SpecPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'KXType1';
      flagname := '款项类型';
      if ShowModal = 1 then
      begin
        Self.YFSub.Edit;
        Self.YFSub.FieldByName('KXType').Value := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYFKInput.v1QtyUnitPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'QtyUnit';
      flagname := '数量单位';
      if ShowModal = 1 then
      begin
        Self.YFSub.Edit;
        Self.YFSub.FieldByName('QtyUnit').Value := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYFKInput.TADDClick(Sender: TObject);
begin
  with YFSub do
  begin
    Append;
    FieldByName('Qty').Value := 0;
    FieldByName('Price').Value := 0;
    FieldByName('MxMoney').Value := 0;
    Post;
  end;

end;

procedure TfrmYFKInput.TDElClick(Sender: TObject);
begin
  if YFSub.IsEmpty then
    exit;
  if application.MessageBox('确定要删除吗', '提示', 1) = 2 then
    exit;

  if trim(YFSub.fieldbyname('YFSID').asstring) = '' then
  begin
    YFSub.delete;
    HJJE();
  end
  else
  begin
    with ADOQueryTmp do
    begin
      close;
      sql.clear;
      sql.add('delete from YF_Money_CR_Sub2 where YFSID=''' + trim(YFSub.fieldbyname('YFSID').asstring) + ''' ');
      execsql;
    end;
    YFSub.delete;
    HJJE();
    TSave.Click;
  end;

end;

procedure TfrmYFKInput.v1QtyPropertiesEditValueChanged(Sender: TObject);
var
  mvalue, FFieldName: string;
  FQty, FPrice, FMxMoney: double;
begin
  mvalue := TcxTextEdit(Sender).EditingText;
  FFieldName := Trim(Tv1.Controller.FocusedColumn.DataBinding.FilterFieldName);
  if Trim(mvalue) = '' then
  begin
    mvalue := '0';
  end;
  with YFSub do
  begin
    Edit;
    FieldByName(FFieldName).Value := Trim(mvalue);
    Post;
  end;
  with YFSub do
  begin
    Edit;
    FQty := FieldByName('Qty').AsFloat;
    FPrice := FieldByName('Price').AsFloat;
    Post;
  end;
  FMxMoney := strtofloat(format('%.2f', [FQty * FPrice]));
  with YFSub do
  begin
    Edit;
    FieldByName(FFieldName).Value := Trim(mvalue);
    FieldbyName('MxMoney').Value := FMxMoney;
    Post;
  end;
  tv1.Controller.EditingController.ShowEdit();
  HJJE();
end;

procedure TfrmYFKInput.SYRNameBtnClick(Sender: TObject);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'GSTTPB';
      flagname := '供方';
      V1Name.Caption := '中文名称';
      if ShowModal = 1 then
      begin
        SYRName.Text := Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYFKInput.v1Column3PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin

  frmProductFileSel := TfrmProductFileSel.Create(self);
  with frmProductFileSel do
  begin
    FYFGSType := TRIM(Self.YFGSType.Text);
    if showmodal = 1 then
    begin
      with YFSub do
      begin
        Edit;
        FieldByName('CPName').Value := Trim(CDS_HZ.fieldbyname('SPName').AsString);
        FieldByName('CPCode').Value := Trim(CDS_HZ.fieldbyname('SPCode').AsString);
        FieldByName('CPSpec').Value := Trim(CDS_HZ.fieldbyname('SPSpec').AsString);
      end;
    end;
    free;
  end;
//  try
//    frmZDYHelp := TfrmZDYHelp.Create(Application);
//    with frmZDYHelp do
//    begin
//      flag := 'MPRTCodeName';
//      flagname := '产品名称';
//      if ShowModal = 1 then
//      begin
//        with YFSub do
//        begin
//          Edit;
//          FieldByName('CPName').Value := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
//          FieldByName('CPCode').Value := Trim(ClientDataSet1.fieldbyname('ZDYNo').AsString);
//        end;
//      end;
//    end;
//  finally
//    frmZDYHelp.Free;
//  end;
  self.tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmYFKInput.HuiLvKeyPress(Sender: TObject; var Key: Char);
begin
  if not (((Key >= '0') and (Key <= '9')) or (Key = '.') or (Key = #8)) then
  begin
    Key := #0;
  end
  else if (pos('.', TEdit(Sender).text) <> 0) then
  begin
    if Key = '.' then
    begin
      Key := #0;
    end;
  end;
end;

procedure TfrmYFKInput.Panel1Click(Sender: TObject);
begin
  yfname.SetFocus;
end;

procedure TfrmYFKInput.HuiLvExit(Sender: TObject);
begin
  HJJE();
end;

procedure TfrmYFKInput.v1MoneyPropertiesEditValueChanged(Sender: TObject);
var
  mvalue, FFieldName: string;
begin
  mvalue := TcxTextEdit(Sender).EditingText;
  FFieldName := Trim(Tv1.Controller.FocusedColumn.DataBinding.FilterFieldName);
  if Trim(mvalue) = '' then
  begin
    mvalue := '0';
  end;
  with YFSub do
  begin
    Edit;
    FieldByName(FFieldName).Value := Trim(mvalue);
    Post;
  end;
  tv1.Controller.EditingController.ShowEdit();
  HJJE();
end;

procedure TfrmYFKInput.ToolButton1Click(Sender: TObject);
var
  CFactoryName: string;
  CostType: integer;
begin
  try
    frmMLRKlistSel := TfrmMLRKlistSel.create(self);
    with frmMLRKlistSel do
    begin
      if showmodal = 1 then
      begin
        CFactoryName := Trim(CDS_Main.fieldbyname('FactoryName1').AsString);
        CRTime.DateTime := CDS_Main.fieldbyname('CRTime').AsDateTime;
//        FSTime.DateTime := CDS_Main.fieldbyname('CRTime').AsDateTime;
        while CDS_Main.Locate('SSel', true, []) do
        begin
          if trim(CFactoryName) <> Trim(CDS_Main.fieldbyname('FactoryName1').AsString) then
          begin
            Application.MessageBox('不能选择多个对方单位!', '提示', 0);
            Exit;
          end;
          self.YFSub.Append;
          self.YFSub.FieldByName('YFPZNO').Value := CDS_Main.FieldByName('CRNO').Value;
//          self.YFSub.FieldByName('OrderNo').Value := CDS_Main.FieldByName('OrderNo').Value;
//          self.YFSub.FieldByName('OrdMainId').Value := CDS_Main.FieldByName('MainId').Value;
//          self.YFSub.FieldByName('OrdSubId').Value := CDS_Main.FieldByName('SubId').Value;
//          self.YFSub.FieldByName('CostDate').Value := CDS_Main.FieldByName('CRTime').Value;
          self.YFSub.FieldByName('CPCode').Value := CDS_Main.FieldByName('P_Code').Value;
          self.YFSub.FieldByName('CPName').Value := CDS_Main.FieldByName('P_CodeName').Value;
          self.YFSub.FieldByName('CPSpec').Value := CDS_Main.FieldByName('P_SPEC').Value;
          self.YFSub.FieldByName('CPColor').Value := CDS_Main.FieldByName('P_Color').Value;
//          self.YFSub.FieldByName('CPGanghao').Value := CDS_Main.FieldByName('ganghao').Value;
          if trim(CDS_Main.FieldByName('CRType').AsString) = '采购入库' then
          begin
            self.YFSub.FieldByName('KXType').Value := '采购费';
            CostType := 1;
          end
          else if trim(CDS_Main.FieldByName('CRType').AsString) = '加工完成' then
          begin
            self.YFSub.FieldByName('KXType').Value := '加工费';
            CostType := 1;
          end
          else if trim(CDS_Main.FieldByName('CRType').AsString) = '回修完成' then
          begin
            self.YFSub.FieldByName('KXType').Value := '回修费';
            CostType := 1;
          end
          else if trim(CDS_Main.FieldByName('CRType').AsString) = '退货出库' then
          begin
            self.YFSub.FieldByName('KXType').Value := '退货费用';
            CostType := -1;
          end
          else
          begin
            CostType := 1;
          end;

          self.YFSub.FieldByName('PS').Value := CostType * CDS_Main.FieldByName('Rollnum').AsFloat;
          self.YFSub.FieldByName('Qty').Value := CostType * CDS_Main.FieldByName('Qty').AsFloat;
          self.YFSub.FieldByName('MxMoney').Value := CostType * CDS_Main.FieldByName('Money').AsFloat;

          self.YFSub.FieldByName('Price').Value := CDS_Main.FieldByName('Price').Value;
          self.YFSub.FieldByName('QtyUnit').Value := CDS_Main.FieldByName('QtyUnit').Value;
          self.YFSub.post;
          CDS_Main.Delete;
        end;
        self.FactoryName.Text := Trim(CFactoryName);
        HJJE();
      end;
    end;
  finally
    frmMLRKlistSel.free;
  end;
end;

procedure TfrmYFKInput.YFNameBtnClick(Sender: TObject);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'YFName1';
      flagname := '项目及摘要';
      if ShowModal = 1 then
      begin
        YFName.Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYFKInput.FtySYRNameBtnClick(Sender: TObject);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'YFFtySYRName';
      flagname := '对方抬头';
      if ShowModal = 1 then
      begin
        FtySYRName.Text := Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYFKInput.ToolButton4Click(Sender: TObject);
begin
  if YFSub.IsEmpty = False then
  begin
    CopyAddRowCDS(YFSub);
    with YFSub do
    begin
      Edit;
      FieldByName('YFSID').Value := null;
      post;
    end;
  end;
end;

end.

